/*-------------------------------------------------------------------------*\
 |                                                                         |
 |                                                                         |
 |  WE_EXT.H - Include file for WinEdit DLL Extension Processor            |
 |                                                                         |
 |                                                                         |
\*-------------------------------------------------------------------------*/

#include "we_extrc.h"



/*
 *  lParam struct used in the WEM_SEARCH* messages
 *  to pass the search and replace parameters
 */

typedef struct tagSEARCHRECORD
   {
   UINT      fComplain:    1;    /* show 'not found' etc. to user      */
   UINT      fPrompt:      1;    /* bring up search/replace dialog box */
   UINT      fMatchCase:   1;    /* exact case match only              */
   UINT      fForward:     1;    /* forward direction                  */
   UINT      fChangeAll:   1;    /* change all                         */
   UINT      fConfirm:     1;    /* ask user to confirm changes        */
   UINT      fRegular:     1;    /* use regular expression             */
   UINT      fUnused:      9;
   LPSTR     lpSearchText;       /* string to search for               */
   LPSTR     lpReplaceText;      /* string to replace found text with  */
   } SEARCHRECORD;

typedef SEARCHRECORD FAR *LPSEARCHRECORD;

/*
 *  function prototypes
 *
 */
int WINAPI edFileNew(HWND hWnd);
int WINAPI edFileOpen(HWND hWnd, LPSTR lpFileName);
int WINAPI edFileMerge(HWND hWnd, LPSTR lpFileName);
int WINAPI edFileSave(HWND hWnd);
int WINAPI edFileSaveAs(HWND hWnd, LPSTR lpFileName);
int WINAPI edFilePrint(HWND hWnd);
int WINAPI edFilePageSetup(HWND hWnd);
int WINAPI edFilePrinterSetup(HWND hWnd);
int WINAPI edFileSetPreferences(HWND hWnd);
int WINAPI edFileExit(HWND hWnd);
int WINAPI edFileList(HWND hWnd);

int WINAPI edEditUndo(HWND hWnd);
int WINAPI edEditRedo(HWND hWnd);
int WINAPI edEditCut(HWND hWnd);
int WINAPI edEditCopy(HWND hWnd);
int WINAPI edEditPaste(HWND hWnd);
int WINAPI edEditDelete(HWND hWnd);
int WINAPI edEditToggleIns(HWND hWnd);
int WINAPI edEditWrap(HWND hWnd);
int WINAPI edEditSetColumnBlock(HWND hWnd);
int WINAPI edEditInsertString(HWND hWnd, LPSTR lpString);
int WINAPI edEditBackspace(HWND hWnd);
int WINAPI edEditSelectAll(HWND hWnd);
int WINAPI edEditCopyLine(HWND hWnd);
int WINAPI edEditCutLine(HWND hWnd);
int WINAPI edEditGoToLine(HWND hWnd, int iLineNo);
int WINAPI edEditGoToColumn(HWND hWnd, int iColNo);
int WINAPI edEditBeginningOfLine(HWND hWnd);
int WINAPI edEditEndOfLine(HWND hWnd);
int WINAPI edEditBeginningOfFile(HWND hWnd);
int WINAPI edEditEndOfFile(HWND hWnd);
int WINAPI edEditUpLine(HWND hWnd);
int WINAPI edEditDownLine(HWND hWnd);
int WINAPI edEditLeft(HWND hWnd);
int WINAPI edEditRight(HWND hWnd);
int WINAPI edEditPageUp(HWND hWnd);
int WINAPI edEditPageDown(HWND hWnd);
int WINAPI edEditWordLeft(HWND hWnd);
int WINAPI edEditWordRight(HWND hWnd);
int WINAPI edEditStartSelection(HWND hWnd);
int WINAPI edEditEndSelection(HWND hWnd);
int WINAPI edEditClearSelection(HWND hWnd);
int WINAPI edEditSetBookMark(HWND hWnd, int iMark);
int WINAPI edEditGoToBookMark(HWND hWnd, int iMark);
int WINAPI edEditTab(HWND hWnd);
int WINAPI edEditBackTab(HWND hWnd);
int WINAPI edEditGetCurrentWord(HWND hWnd, LPSTR lpBuffer, int iLength);
int WINAPI edSearchFind(HWND hWnd, LPSEARCHRECORD lpSearch);
int WINAPI edSearchRepeat(HWND hWnd, LPSEARCHRECORD lpSearch);
int WINAPI edSearchChange(HWND hWnd, LPSEARCHRECORD lpSearch);
int WINAPI edSearchNextError(HWND hWnd);
int WINAPI edSearchPrevError(HWND hWnd);
int WINAPI edSearchViewOutput(HWND hWnd);

int WINAPI edRunCompile(HWND hWnd);
int WINAPI edRunMake(HWND hWnd);
int WINAPI edRunRebuild(HWND hWnd);
int WINAPI edRunDebug(HWND hWnd);
int WINAPI edRunExecute(HWND hWnd);
int WINAPI edRunCommand(HWND hWnd, BOOL bWait, BOOL bCapture, LPSTR lpCommand);
int WINAPI edRunConfigure(HWND hWnd);

int WINAPI edWindowTile(HWND hWnd);
int WINAPI edWindowCascade(HWND hWnd);
int WINAPI edWindowArrangeIcons(HWND hWnd);
int WINAPI edWindowNext(HWND hWnd);
int WINAPI edWindowMinimize(HWND hWnd);
int WINAPI edWindowMaximize(HWND hWnd);
int WINAPI edWindowRestore(HWND hWnd);
int WINAPI edWindowClose(HWND hWnd);
int WINAPI edWindowCloseAll(HWND hWnd);

int WINAPI edHelpIndex(HWND hWnd);
int WINAPI edHelpKeyboard(HWND hWnd);
int WINAPI edHelpCommands(HWND hWnd);
int WINAPI edHelpProcedures(HWND hWnd);
int WINAPI edHelpKeyWord(HWND hWnd);
int WINAPI edHelpHelp(HWND hWnd);
int WINAPI edHelpAbout(HWND hWnd);

int WINAPI edAddButton(HWND hWnd, WORD wIcon, WORD wCommand, WORD wPosition);
int WINAPI edDeleteButton(HWND hWnd, WORD wPosition, WORD wCommand);

int WINAPI edGetModifiedStatus(HWND hWnd);
int WINAPI edGetLineNumber(HWND hWnd);
int WINAPI edGetColumnNumber(HWND hWnd);
int WINAPI edGetSelectionState(HWND hWnd, LPPOINT ptStart, LPPOINT ptEnd);
int WINAPI edGetUndoState(HWND hWnd);
int WINAPI edGetRedoState(HWND hWnd);
int WINAPI edGetWordWrapState(HWND hWnd);
int WINAPI edGetInsertState(HWND hWnd);
int WINAPI edGetWindowName(HWND hWnd, LPSTR lpBuffer, int iSize);
int WINAPI edGetChar(HWND hWnd);
int WINAPI edRecord(HWND hWnd);
int WINAPI edStatusMsg(HWND hWnd, LPSTR lpString);
